/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the SecurityDto type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &SecurityDto{}

// SecurityDto struct for SecurityDto
type SecurityDto struct {
	AccessToken  *string     `json:"access_token,omitempty"`
	RefreshToken *string     `json:"refresh_token,omitempty"`
	Provider     interface{} `json:"provider,omitempty"`
	RealmId      *int32      `json:"realm_id,omitempty"`
	ExpiresIn    *int32      `json:"expires_in,omitempty"`
}

// NewSecurityDto instantiates a new SecurityDto object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewSecurityDto() *SecurityDto {
	this := SecurityDto{}
	return &this
}

// NewSecurityDtoWithDefaults instantiates a new SecurityDto object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewSecurityDtoWithDefaults() *SecurityDto {
	this := SecurityDto{}
	return &this
}

// GetAccessToken returns the AccessToken field value if set, zero value otherwise.
func (o *SecurityDto) GetAccessToken() string {
	if o == nil || IsNil(o.AccessToken) {
		var ret string
		return ret
	}
	return *o.AccessToken
}

// GetAccessTokenOk returns a tuple with the AccessToken field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SecurityDto) GetAccessTokenOk() (*string, bool) {
	if o == nil || IsNil(o.AccessToken) {
		return nil, false
	}
	return o.AccessToken, true
}

// HasAccessToken returns a boolean if a field has been set.
func (o *SecurityDto) HasAccessToken() bool {
	if o != nil && !IsNil(o.AccessToken) {
		return true
	}

	return false
}

// SetAccessToken gets a reference to the given string and assigns it to the AccessToken field.
func (o *SecurityDto) SetAccessToken(v string) {
	o.AccessToken = &v
}

// GetRefreshToken returns the RefreshToken field value if set, zero value otherwise.
func (o *SecurityDto) GetRefreshToken() string {
	if o == nil || IsNil(o.RefreshToken) {
		var ret string
		return ret
	}
	return *o.RefreshToken
}

// GetRefreshTokenOk returns a tuple with the RefreshToken field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SecurityDto) GetRefreshTokenOk() (*string, bool) {
	if o == nil || IsNil(o.RefreshToken) {
		return nil, false
	}
	return o.RefreshToken, true
}

// HasRefreshToken returns a boolean if a field has been set.
func (o *SecurityDto) HasRefreshToken() bool {
	if o != nil && !IsNil(o.RefreshToken) {
		return true
	}

	return false
}

// SetRefreshToken gets a reference to the given string and assigns it to the RefreshToken field.
func (o *SecurityDto) SetRefreshToken(v string) {
	o.RefreshToken = &v
}

// GetProvider returns the Provider field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *SecurityDto) GetProvider() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.Provider
}

// GetProviderOk returns a tuple with the Provider field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *SecurityDto) GetProviderOk() (*interface{}, bool) {
	if o == nil || IsNil(o.Provider) {
		return nil, false
	}
	return &o.Provider, true
}

// HasProvider returns a boolean if a field has been set.
func (o *SecurityDto) HasProvider() bool {
	if o != nil && IsNil(o.Provider) {
		return true
	}

	return false
}

// SetProvider gets a reference to the given interface{} and assigns it to the Provider field.
func (o *SecurityDto) SetProvider(v interface{}) {
	o.Provider = v
}

// GetRealmId returns the RealmId field value if set, zero value otherwise.
func (o *SecurityDto) GetRealmId() int32 {
	if o == nil || IsNil(o.RealmId) {
		var ret int32
		return ret
	}
	return *o.RealmId
}

// GetRealmIdOk returns a tuple with the RealmId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SecurityDto) GetRealmIdOk() (*int32, bool) {
	if o == nil || IsNil(o.RealmId) {
		return nil, false
	}
	return o.RealmId, true
}

// HasRealmId returns a boolean if a field has been set.
func (o *SecurityDto) HasRealmId() bool {
	if o != nil && !IsNil(o.RealmId) {
		return true
	}

	return false
}

// SetRealmId gets a reference to the given int32 and assigns it to the RealmId field.
func (o *SecurityDto) SetRealmId(v int32) {
	o.RealmId = &v
}

// GetExpiresIn returns the ExpiresIn field value if set, zero value otherwise.
func (o *SecurityDto) GetExpiresIn() int32 {
	if o == nil || IsNil(o.ExpiresIn) {
		var ret int32
		return ret
	}
	return *o.ExpiresIn
}

// GetExpiresInOk returns a tuple with the ExpiresIn field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SecurityDto) GetExpiresInOk() (*int32, bool) {
	if o == nil || IsNil(o.ExpiresIn) {
		return nil, false
	}
	return o.ExpiresIn, true
}

// HasExpiresIn returns a boolean if a field has been set.
func (o *SecurityDto) HasExpiresIn() bool {
	if o != nil && !IsNil(o.ExpiresIn) {
		return true
	}

	return false
}

// SetExpiresIn gets a reference to the given int32 and assigns it to the ExpiresIn field.
func (o *SecurityDto) SetExpiresIn(v int32) {
	o.ExpiresIn = &v
}

func (o SecurityDto) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o SecurityDto) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.AccessToken) {
		toSerialize["access_token"] = o.AccessToken
	}
	if !IsNil(o.RefreshToken) {
		toSerialize["refresh_token"] = o.RefreshToken
	}
	if o.Provider != nil {
		toSerialize["provider"] = o.Provider
	}
	if !IsNil(o.RealmId) {
		toSerialize["realm_id"] = o.RealmId
	}
	if !IsNil(o.ExpiresIn) {
		toSerialize["expires_in"] = o.ExpiresIn
	}
	return toSerialize, nil
}

type NullableSecurityDto struct {
	value *SecurityDto
	isSet bool
}

func (v NullableSecurityDto) Get() *SecurityDto {
	return v.value
}

func (v *NullableSecurityDto) Set(val *SecurityDto) {
	v.value = val
	v.isSet = true
}

func (v NullableSecurityDto) IsSet() bool {
	return v.isSet
}

func (v *NullableSecurityDto) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSecurityDto(val *SecurityDto) *NullableSecurityDto {
	return &NullableSecurityDto{value: val, isSet: true}
}

func (v NullableSecurityDto) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSecurityDto) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
